"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _assign = _interopRequireDefault(require("@babel/runtime/core-js/object/assign"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _stringify = _interopRequireDefault(require("@babel/runtime/core-js/json/stringify"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRedux = require("react-redux");

var _actions = _interopRequireDefault(require("./actions"));

var _get_aggregate_actions = _interopRequireDefault(require("./get_aggregate_actions"));

var readModelPropsNames = ['readModelName', 'resolverName', 'parameters', 'isReactive'];

var compareReadModelProps = function compareReadModelProps(nextProps, prevProps) {
  return readModelPropsNames.reduce(function (acc, key) {
    return acc && (0, _stringify.default)(nextProps[key]) === (0, _stringify.default)(prevProps[key]);
  }, true);
};

var extractReadModelProps = function extractReadModelProps(props) {
  return readModelPropsNames.reduce(function (acc, key) {
    acc[key] = props[key];
    return acc;
  }, {});
};

var extractReadModelValues = function extractReadModelValues(props) {
  return readModelPropsNames.map(function (key) {
    return props[key];
  });
};

var connectReadModel = function connectReadModel(mapStateToProps, mapDispatchToProps, mergeProps, options) {
  return function (Component) {
    var ConnectedComponent = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps, mergeProps, options)(Component);

    var ReadModelConnector =
    /*#__PURE__*/
    function (_React$PureComponent) {
      (0, _inherits2.default)(ReadModelConnector, _React$PureComponent);

      function ReadModelConnector() {
        var _getPrototypeOf2;

        var _this;

        (0, _classCallCheck2.default)(this, ReadModelConnector);

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(ReadModelConnector)).call.apply(_getPrototypeOf2, [this].concat(args)));
        (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "aggregateActions", (0, _get_aggregate_actions.default)(_this.context.store));
        return _this;
      }

      (0, _createClass2.default)(ReadModelConnector, [{
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps) {
          var readModelProps = extractReadModelProps(mapStateToProps(this.context.store.getState(), (0, _objectSpread2.default)({}, nextProps, {
            aggregateActions: this.aggregateActions
          })));
          if (compareReadModelProps(readModelProps, this)) return;
          this.context.store.dispatch(_actions.default.unsubscribeReadModel(this.readModelName, this.resolverName));
          this.context.store.dispatch(_actions.default.subscribeReadModel.apply(_actions.default, (0, _toConsumableArray2.default)(extractReadModelValues(readModelProps))));
          (0, _assign.default)(this, readModelProps);
        }
      }, {
        key: "componentDidMount",
        value: function componentDidMount() {
          var readModelProps = extractReadModelProps(mapStateToProps(this.context.store.getState(), (0, _objectSpread2.default)({}, this.props, {
            aggregateActions: this.aggregateActions
          })));
          this.context.store.dispatch(_actions.default.subscribeReadModel.apply(_actions.default, (0, _toConsumableArray2.default)(extractReadModelValues(readModelProps))));
          (0, _assign.default)(this, readModelProps);
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.context.store.dispatch(_actions.default.unsubscribeReadModel(this.readModelName, this.resolverName));
        }
      }, {
        key: "render",
        value: function render() {
          return _react.default.createElement(ConnectedComponent, (0, _extends2.default)({}, this.props, {
            aggregateActions: this.aggregateActions
          }));
        }
      }]);
      return ReadModelConnector;
    }(_react.default.PureComponent);

    ReadModelConnector.contextTypes = {
      store: _propTypes.default.object.isRequired
    };
    return ReadModelConnector;
  };
};

var _default = connectReadModel;
exports.default = _default;