"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRedux = require("react-redux");

var _is_loading_view_model = _interopRequireDefault(require("./is_loading_view_model"));

var _get_aggregate_actions = _interopRequireDefault(require("./get_aggregate_actions"));

var _actions = _interopRequireDefault(require("./actions"));

var connectViewModel = function connectViewModel(mapStateToProps, mapDispatchToProps, mergeProps, options) {
  return function (Component) {
    var ConnectedComponent = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps, mergeProps, options)(Component);

    var ViewModelConnector =
    /*#__PURE__*/
    function (_React$PureComponent) {
      (0, _inherits2.default)(ViewModelConnector, _React$PureComponent);

      function ViewModelConnector() {
        (0, _classCallCheck2.default)(this, ViewModelConnector);
        return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ViewModelConnector).apply(this, arguments));
      }

      (0, _createClass2.default)(ViewModelConnector, [{
        key: "componentWillMount",
        value: function componentWillMount() {
          var _mapStateToProps = mapStateToProps(this.context.store.getState(), this.props),
              viewModelName = _mapStateToProps.viewModelName,
              aggregateId = _mapStateToProps.aggregateId;

          this.viewModelName = viewModelName;
          this.aggregateId = aggregateId;
          this.context.store.dispatch(_actions.default.subscribeViewModel(this.viewModelName, this.aggregateId));
        }
      }, {
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps) {
          var _mapStateToProps2 = mapStateToProps(this.context.store.getState(), nextProps),
              viewModelName = _mapStateToProps2.viewModelName,
              aggregateId = _mapStateToProps2.aggregateId;

          if (viewModelName !== this.viewModelName || aggregateId !== this.aggregateId) {
            this.context.store.dispatch(_actions.default.unsubscribeViewModel(this.viewModelName, this.aggregateId));
            this.viewModelName = viewModelName;
            this.aggregateId = aggregateId;
            this.context.store.dispatch(_actions.default.subscribeViewModel(this.viewModelName, this.aggregateId));
          }
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.context.store.dispatch(_actions.default.unsubscribeViewModel(this.viewModelName, this.aggregateId));
        }
      }, {
        key: "render",
        value: function render() {
          var loading = (0, _is_loading_view_model.default)(this.context.store, this.viewModelName, this.aggregateId);
          var aggregateActions = (0, _get_aggregate_actions.default)(this.context.store);
          return _react.default.createElement(ConnectedComponent, (0, _extends2.default)({}, this.props, {
            loading: loading,
            aggregateActions: aggregateActions
          }));
        }
      }]);
      return ViewModelConnector;
    }(_react.default.PureComponent);

    ViewModelConnector.contextTypes = {
      store: _propTypes.default.object.isRequired
    };
    return ViewModelConnector;
  };
};

var _default = connectViewModel;
exports.default = _default;