"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _socket = _interopRequireDefault(require("socket.io-client"));

var _utils = require("./utils");

var subscribeAdapter = function subscribeAdapter(_ref) {
  var origin = _ref.origin,
      rootPath = _ref.rootPath;

  var _onEvent, _onDisconnect;

  var socket = (0, _socket.default)(origin, {
    path: (0, _utils.getRootBasedUrl)('', rootPath, '/socket')
  });
  var latePromise = (0, _utils.makeLateResolvingPromise)();
  socket.on('event', function (event) {
    return _onEvent(JSON.parse(event));
  });
  socket.on('connect', function () {
    return latePromise.resolve(socket.id);
  });
  socket.on('reconnect', function () {
    latePromise = (0, _utils.makeLateResolvingPromise)(socket.id);
  });
  socket.on('disconnect', function (reason) {
    latePromise = (0, _utils.makeLateResolvingPromise)();

    _onDisconnect(reason);
  });
  return {
    onEvent: function onEvent(callback) {
      _onEvent = callback;
    },
    onDisconnect: function onDisconnect(callback) {
      _onDisconnect = callback;
    },
    setSubscription: function setSubscription(_ref2) {
      var aggregateIds = _ref2.aggregateIds,
          types = _ref2.types;
      socket.emit('setSubscription', {
        ids: aggregateIds,
        // TODO. Fix server-side
        types: types
      });
    },
    getClientId: function () {
      var _getClientId = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return latePromise;

              case 2:
                return _context.abrupt("return", _context.sent);

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function getClientId() {
        return _getClientId.apply(this, arguments);
      };
    }()
  };
};

var _default = subscribeAdapter;
exports.default = _default;