"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _actions = _interopRequireDefault(require("./actions"));

var _load_initial_state = _interopRequireDefault(require("./load_initial_state"));

var _utils = require("./utils");

var subscribeViewModel =
/*#__PURE__*/
function () {
  var _ref2 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(_ref, action) {
    var origin, rootPath, store, adapter, viewModels, subscribers, requests, viewModelName, aggregateId, needChange, key, rawState, state;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            origin = _ref.origin, rootPath = _ref.rootPath, store = _ref.store, adapter = _ref.adapter, viewModels = _ref.viewModels, subscribers = _ref.subscribers, requests = _ref.requests;
            viewModelName = action.viewModelName, aggregateId = action.aggregateId;
            needChange = !subscribers.viewModels[viewModelName] || !subscribers.aggregateIds[aggregateId];
            subscribers.viewModels[viewModelName] = (subscribers.viewModels[viewModelName] || 0) + 1;
            subscribers.aggregateIds[aggregateId] = (subscribers.aggregateIds[aggregateId] || 0) + 1;

            if (!needChange) {
              _context.next = 13;
              break;
            }

            key = (0, _utils.getKey)(viewModelName, aggregateId);
            requests[key] = true;
            _context.next = 10;
            return (0, _load_initial_state.default)({
              origin: origin,
              rootPath: rootPath
            }, viewModelName, aggregateId);

          case 10:
            rawState = _context.sent;
            state = viewModels.find(function (_ref3) {
              var name = _ref3.name;
              return name === viewModelName;
            }).deserializeState(rawState);

            if (requests[key]) {
              delete requests[key];
              store.dispatch(_actions.default.merge(viewModelName, aggregateId, state));
              adapter.setSubscription({
                types: (0, _utils.getEventTypes)(viewModels, subscribers),
                aggregateIds: (0, _utils.getAggregateIds)(viewModels, subscribers)
              });
            }

          case 13:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function subscribeViewModel(_x, _x2) {
    return _ref2.apply(this, arguments);
  };
}();

var _default = subscribeViewModel;
exports.default = _default;